=== debian/changelog ===
libtrexio (2.2.3-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:48:23 +0000

libtrexio (2.2.3-3build1) noble; urgency=medium

  * No-change rebuild against libhdf5-103-1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 18:00:34 +0000

libtrexio (2.2.3-3) unstable; urgency=medium

  * Team upload.

  [ Evgeny Posenitskiy ]
  * First patch for parallel tests to pass (sparc64)
  * Add patch for Fortran interface on the 32-bit systems

 -- Andrius Merkys <merkys@debian.org>  Fri, 07 Oct 2022 08:07:45 -0400

libtrexio (2.2.3-2) unstable; urgency=medium

  * Team upload.

  [ Evgeny Posenitskiy ]
  * Add debian/watch

  [ Andrius Merkys ]
  * Adjust licenses for files under m4/.

 -- Andrius Merkys <merkys@debian.org>  Mon, 03 Oct 2022 01:39:11 -0400

libtrexio (2.2.3-1) unstable; urgency=medium

  * Initial release (Closes: #1020772)  

 -- Evgeny Posenitskiy <posenitskiy@irsamc.ups-tlse.fr>  Tue, 27 Sep 2022 10:34:39 +0200
