=== debian/control ===
Source: libtrexio
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Evgeny Posenitskiy <posenitskiy@irsamc.ups-tlse.fr> 
Build-Depends: debhelper-compat (= 12), 
               gfortran,
               pkg-config,
               libhdf5-dev
Standards-Version: 4.4.1
Homepage: https://github.com/TREX-CoE/trexio
Vcs-Browser: https://salsa.debian.org/debichem-team/libtrexio
Vcs-Git: https://salsa.debian.org/debichem-team/libtrexio.git

Package: libtrexio-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libtrexio0 (= ${binary:Version}), ${misc:Depends}
Description: TREX I/O library for efficient data I/O in quantum chemistry.
 This package contains the static C library, C headers 
 and the Fortran modules necessary for developers.
 
Package: libtrexio0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: TREX I/O library for efficient data I/O in quantum chemistry.
 This package contains the shared C library.
