=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/trexio-$1\.tar\.gz/ \
  https://github.com/TREX-CoE/trexio/tags .*/v?(\d\S+)\.tar\.gz
